﻿
local AssignSoldier = foundation.createMod();

_assignSoldierPrefix = "ASSIGN_SOLDIER_V3"

AssignSoldier:log("Hello World: AssignSoldier")
--AssignSoldier:logWarning("This is a warning!")
--AssignSoldier:logError("This is an error!")
--AssignSoldier:msgBox("AssignSoldier: Hello there")

if (foundation.getGameVersion == nil) or (version.cmp(foundation.getGameVersion(), "1.6") < 0) then
    AssignSoldier:msgBox("AssignSoldier: game version anterior to 1.6")
    return
end
AssignSoldier:msgBox("AssignSoldier: game version" .. foundation.getGameVersion())

function checkVersion(_name, _id, _minimalVersion)
    if (foundation.getModVersion == nil) then
        AssignSoldier:msgBox("AssignSoldier: Unknown mod version")
        return false
    end
    if not foundation.isModEnabled(_id) then
        AssignSoldier:msgBox("AssignSoldier: " .. _name .. " disabled")
        return false
    end
    if not foundation.isModLoaded(_id) then
        AssignSoldier:msgBox("AssignSoldier: Up the position of " .. _name .. " in the mod list of your game")
        return false
    end
    local _myVersion = foundation.getModVersion(_id)
    AssignSoldier:msgBox("AssignSoldier: " .. _name .. " Current version : " .. _myVersion)
    if version.cmp(_myVersion, _minimalVersion) < 0 then
        AssignSoldier:msgBox("AssignSoldier: Please, load the last version of " .. _name)
        return false
    end
    return true
end

-- check all the mandatory dependencies
local flag1 = checkVersion("Window Decorations", "ed248b2a-9fe9-4191-9582-22ad3cf4b0b6", "1.3.0")
local flag2 = checkVersion("Stone Gate Set V5", "ac68bde5-51f9-4eb1-8345-bd71ed4dc8c4", "5.7.5")
if not (flag1 and flag2) then
    return 
end

-- check if Stone Gate Set V6, if present, contains the navigable zones
checkVersion("Stone Gate Set V6", "1433bf89-91e8-4da3-b1e6-e8d8307b86ea", "6.5.0")

AssignSoldier:dofile("scripts/monument.lua")
